#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>


	FILE	        *fpin, *tilefile, *palfile;
	long            len,pixZone,width,height,tilesNum,tile,tileX,tileY,colour;
	short           colNum;

int main(int argc, char *argv[])
{

	if (argc != 2 ) {
		printf("Bitmap converter to 4bpp 16x16 tile data.\n");
		fprintf(stdout,"Usage: %s [srcfile].bmp\n",argv[0]);
		exit(1);
	}

	
	if ( (fpin=fopen(argv[1],"rb") ) == NULL ) {
		
		printf("Can't open input file\n");
		exit(1);
	}


/*
 *	Now we try to determine the size of the file
 *	to be converted
 */
	if	(fseek(fpin,0,SEEK_END)) {
		printf("Couldn't determine size of file\n");
		fclose(fpin);
		exit(1);
	}

	len=ftell(fpin);

	fseek(fpin,0L,SEEK_SET);
	
    unsigned char bytStr[len];

    fread(bytStr, 1, len, fpin);
    
    if	(bytStr[0]!='B') {
		printf("The only supported format is BMP.\n");
		fclose(fpin);
		exit(1);
	}
    
    if	(bytStr[1]!='M') {
		printf("The only supported format is BMP.\n");
		fclose(fpin);
		exit(1);
	}
    
    if	(bytStr[28]!=4) {
		printf("The only supported colour depth is 4bpp.\n");
		fclose(fpin);
		exit(1);
	}
    
    if	((bytStr[30]|(bytStr[31]<<8)|(bytStr[32]<<16)|(bytStr[33]<<24))!=0) {
		printf("Compressed images is not supported for a while.\n");
		fclose(fpin);
		exit(1);
	}
    
    if	((bytStr[2]|(bytStr[3]<<8)|(bytStr[4]<<16)|(bytStr[5]<<24))!=len) {
		printf("The file is broken!\n");
		fclose(fpin);
		exit(1);
	}
    
    pixZone=(bytStr[10]|(bytStr[11]<<8)|(bytStr[12]<<16)|(bytStr[13]<<24));
    
    width=(bytStr[18]|(bytStr[19]<<8)|(bytStr[20]<<16)|(bytStr[21]<<24));
    
    height=(bytStr[22]|(bytStr[23]<<8)|(bytStr[24]<<16)|(bytStr[25]<<24));
    
    if(width%16!=0||height%16!=0) {
		printf("The image is not power-of-16!\n");
		fclose(fpin);
		exit(1);
    }
    
    if ( (tilefile=fopen("tiles.bin","wb") ) == NULL ) {
		printf("Can't open output file\n");
		exit(1);
	}
	
	if ( (palfile=fopen("pal.bin","wb") ) == NULL ) {
		printf("Can't open output file\n");
		exit(1);
	}
    
    width/=2;
    
    tilesNum=width*height/128;
    
    for(tile=0;tile<tilesNum;tile++)
    {
     for(tileY=0;tileY<16;tileY++)
     {
      for(tileX=0;tileX<8;tileX++)
      {
       fputc(bytStr[len-(((tilesNum-tile-1)%(width/8))*8)-((tile/(width/8))*width*16)-(tileY*width)-(7-tileX)-1],tilefile);
      }
     }
    }
    
    for(colNum=0;colNum<16;colNum++)
    {
     colour=(bytStr[54+colNum*4]|(bytStr[55+colNum*4]<<8)|(bytStr[56+colNum*4]<<16));
     colour=(((colour&0xF80000)>>9)|((colour&0xF800)>>6)|((colour&0xFF)>>3));
     fputc(((colour&0xFF00)>>8),palfile);
     fputc((colour&0xFF),palfile);
    }

	fclose(fpin);
	fclose(tilefile);
	fclose(palfile);
}
